<?php
class ControllerPaymentPaysbuy extends Controller {

	public function index() {

		$this->language->load('payment/paysbuy');
		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		//เปลี่ยนภาษา
		$paysbuy_languages=array(
			'th'=>'t',
			'en'=>'e',
			'jp'=>'j',
			'cn'=>'c',
			'nl'=>'e'
		);
		
		if (array_key_exists($this->session->data['language'],$paysbuy_languages)){
			$lang=$paysbuy_languages[$this->session->data['language']];
		}else{
			$lang='t';//default Thai language
		}		

		//ส่งไปหน้า paysbuy
		if ($this->config->get('paysbuy_transaction')=="1") {
    		$data['action'] = 'https://www.paysbuy.com/paynow.aspx?lang='.$lang;
  		} else {
			$data['action'] = 'https://demo.paysbuy.com/paynow.aspx?lang='.$lang;
		}	
		
		if ($order_info) {
			
			$data['button_confirm'] = $this->language->get('button_confirm');
			$data['button_back'] = $this->language->get('button_back');
			
			//ค่าส่งไป paysbuy
			$data['youraccount'] = html_entity_decode($this->config->get('paysbuy_email'), ENT_QUOTES, 'UTF-8');
			$data['invoice'] = $this->session->data['order_id'] ;
			$data['price'] = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
			
			//ดึงชื่อสินค้ามาแสดง
			$data['products'] = array();
			
			foreach ($this->cart->getProducts() as $product) {		
				$data['products'][] = array(
					'name'     => $product['name']
				);
				$title_item[]=$product['name'];
			}
			$data['description'] =implode(",", $title_item);	
	
			//เปลี่ยนค่าเงิน 

			 $cur=$this->currency->getCode() ;

			$currencies = array(
				'AUD',
				'CAD',
				'EUR',
				'GBP',
				'JPY',
				'USD',
				'NZD',
				'CHF',
				'HKD',
				'SGD',
				'SEK',
				'DKK',
				'PLN',
				'NOK',
				'HUF',
				'CZK',
				'ILS',
				'MXN',
				'MYR',
				'BRL',
				'PHP',
				'TWD',
				'THB',
				'TRY',
				'THB'
			);
			
			$paysbuy_currencies= array(
				'THB'=>'764',
				'AUD'=>'036',
				'GBP'=>'826',
				'EUR'=>'978',
				'HKD'=>'344',
				'JPY'=>'392',
				'NZD'=>'554',
				'SGD'=>'702',
				'CHF'=>'756',
				'USD'=>'840'
			);
				
			
			if (in_array($order_info['currency_code'], $currencies)) {
				if (array_key_exists($order_info['currency_code'],$paysbuy_currencies)){
					$currency = $paysbuy_currencies[$order_info['currency_code']];
					//$currency = $order_info['currency_code'];
				}else{
					$currency = '764';//Default THB
				}
			} else {
				$currency = '764';//Default THB
			}			
						
			$data['currencyCode'] =$currency;
			$data['postURL'] =$this->url->link('payment/paysbuy/callback');
			$data['reqURL'] =$this->url->link('payment/paysbuy/callbackground');
			
		
			if ($this->config->get('paysbuy_transaction')=="1") {
				$data['paymentaction'] = 'Payment';
			} else {
				$data['paymentaction'] = 'Test';
			}

			$this->model_checkout_order->confirm($this->session->data['order_id'], "1");
				
			if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/paysbuy.tpl')) {
				return $this->load->view($this->config->get('config_template') . '/template/payment/paysbuy.tpl', $data);
			} else {
				return $this->load->view('default/template/payment/paysbuy.tpl', $data);
			}
		}
	}
	
	public function callback() {


		$this->language->load('payment/paysbuy');

        $method_p = utf8_substr($this->request->post['method'],0,2);  //01 ชำระเงินด้วย PAYSBUY Account , 02 ชำระด้วยบัตรเครดิต

		if($method_p=="01") $method_pay=$this->language->get('text_pay_method1');
		if($method_p=="02") $method_pay=$this->language->get('text_pay_method2');
		if($method_p=="03") $method_pay=$this->language->get('text_pay_method3');
		if($method_p=="04") $method_pay=$this->language->get('text_pay_method4');
		if($method_p=="05") $method_pay=$this->language->get('text_pay_method5');
		if($method_p=="06") $method_pay=$this->language->get('text_pay_method6');

		$apCode=	$this->request->post['apCode'];	//รหัสของ paysbuy

		$amt=$this->request->post['amt'];	//ยอดการชำระเงิน

		$result = utf8_substr($this->request->post['result'],0,2); 	 //00 สำเร็จ ,01 เงินไม่พอ ,99  error


       $data['button_continue'] = $this->language->get('button_continue');

        $data['continue']= $this->url->link('checkout/checkout');

      	$data['breadcrumbs'] = array();

      	$data['breadcrumbs'][] = array(
        	'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home'),        	
        	'separator' => false
      	);

       $this->load->model('checkout/order');

		switch ($result) {
			case "00" :
			      $data['text_message'] = $this->language->get('text_message00').'<br /><br />'. $this->language->get('text_pay_code').$apCode.'<br /><br />'.$this->language->get('text_pay_method').$method_pay.'<br /><br />'.$this->language->get('text_pay_amt').number_format($amt).'<br /><br />'.$this->language->get('text_pay_comp').'<br /><br />';
				  $data['heading_title'] = $this->language->get('heading_title00');

				  $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $this->config->get('paysbuy_order_status_id'));
				  
				  $data['continue']= $this->url->link('checkout/success');
				  break;
			case "02" :
			      $data['text_message'] = $this->language->get('text_message02');
				  $data['heading_title'] = $this->language->get('heading_title02');

				  $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $this->config->get('paysbuy_order_status_id_cs'));

				  $data['continue']= $this->url->link('common/home');
			      break;
			case "99" :
			      $data['text_message'] = $this->language->get('text_message99').'<br /><br />'.$this->language->get('text_pay_error').'<br /><br />';
				  $data['heading_title'] = $this->language->get('heading_title99');
				  $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $this->config->get('paysbuy_order_status_id_failed'));
		          break;
			default:
				  $data['text_message'] = $this->language->get('text_message99').'<br /><br />'.$this->language->get('text_pay_error').'<br /><br />';
				  $data['heading_title'] = $this->language->get('heading_title99');
				  $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $this->config->get('paysbuy_order_status_id_failed'));
	}


		if ($result != '00') {
			
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/common/success.tpl')) {
			return $this->load->view($this->config->get('config_template') . '/template/common/success.tpl', $data);
		} else {
			return $this->load->view('default/template/common/success.tpl', $data);
		}
			
		} else{

        $this->response->redirect(HTTPS_SERVER . 'index.php?route=checkout/success');

		}

	}
	
	
	
	public function callbackground() {

		$this->load->model('payment/paysbuy');
		$this->load->model('checkout/order');
		
		$payment_status	 = substr($this->request->post['result'], 0, 2);
		$cartnumber = trim(substr($this->request->post['result'],2));
		$amount = $this->request->post['amt'];
		$psbRef = $this->request->post['apCode'];
	
		if ($payment_status == '00') {
			$this->model_checkout_order->addOrderHistory($cartnumber, $this->config->get('paysbuy_order_status_id'));
		} 
		else if ($payment_status == '02') {
			$this->model_checkout_order->addOrderHistory($cartnumber, $this->config->get('paysbuy_order_status_id_cs'));
		} 
		else{
			$this->model_checkout_order->addOrderHistory($cartnumber, $this->config->get('paysbuy_order_status_id_failed'));
		}
			
		//เก็บ ค่าการ POST จาก Paysbuy
		//$filename='paysbuy_post_logs.log';
		//$log=date("[Y-m-d H:i:s]")."[IP=".$this->model_payment_paysbuy->getuserip()."]".$this->model_payment_paysbuy->http_parse_query($_POST).$error."\r\n";
		//$handle = fopen("logs/payment/".$filename, 'a+');//ต้องสร้าง forder logs/payment และ สร้าง file paysbuy_post_logs.log ทำการ chmod 777 ให้สามารถเขียนได้
		//fwrite($handle, $log);
		//fclose($handle);
		
	}
	
		
}
?>